open Input_util
open Algebra
open Vector
open Matrix

(* functor to build the structure of band matrices 
   (normal, square and symmetric), matrices are stored as an array of
   diagonals. Diagonals with only null elements are not stored *)

module Make
  (R:Ring)
  (Domain:Vector with type scalar = R.elem)
  (Image:Vector with type scalar = R.elem) :
  (Light_Matrix  
   with type scalar = R.elem
   and type argument = Domain.elem
   and type result = Image.elem)

module Make_Square(R:Ring)(Domain:Vector with type scalar = R.elem) :
   (Light_Matrix 
   with type scalar = R.elem
   and type argument = Domain.elem
   and type result = Domain.elem)

module Make_Symmetric(R:Ring)(Domain:Vector with type scalar = R.elem) :
   (Light_Matrix 
   with type scalar = R.elem
   and type argument = Domain.elem
   and type result = Domain.elem)

