open Format
open Algebra
open Expression

module VarReel = 
  (  
    struct
      type var = string 
      type 'a environment = (var*'a) list (* polymorph type *)
      type environreel = float environment (* type exemple for int *)
			      
      let lookup vari env =
	  List.assoc vari env
	    
      let  print_var= print_string 
    end 
  )

module E = Expression(Field_R)
open E

let rec fexp = {name = "exp"; calcul = exp; deriv = Tra(fexp, (var "x"));name_var = "x"}
let rec flog = {name = "log"; calcul = log; deriv = inv(var "x");name_var = "x"}
let rec fsin = {name = "sin"; calcul = sin; deriv = Tra(fcos, (var "x"));name_var = "x"}
    and fcos = {name = "cos"; calcul = cos; deriv = Mul(cst (-1.0), Tra(fsin, (var "x")));name_var = "x"}

let x= var "x"
let y = var "y"
let z = var "z"
let xy = x ** y
let xz = x ** z
let f = trans fexp (x ** x)
let g = trans fsin x ** trans fcos x
let h = f // g

let _ = 
  print_string "f(x) = ";
  print f;
  print_newline ();
  print_string "g(x) = ";
  print g;
  print_newline ();
  print_string "h(x) = ";
  print h;
  print_newline ();
  print_string "f'(x) = ";
  print (derive f "x");
  print_newline ();
  print_string "g'(x) = ";
  print (derive g "x");
  print_newline ();
  print_string "h'(x) = ";
  print (derive h "x");
  print_newline ();
  print_string "h'''''(x) = ";
  print (sder h "x" 5);
  print_newline ();
  print_string "h^(10)(x) = ";
  print (sder h "x" 15);
  print_newline ();
  print_string "h^(15)(x) = ";
  print (sder h "x" 15);
  print_newline ();
