open Format
open Algebra
open Polynomial

module P = Make(Field_R)
open P
  
let p1 = monome 1. 0 ++ monome 2. 1 ++ monome 3. 2
let p2 = monome 4. 0 ++ monome (-2.) 1 ++ monome (-3.) 2
let p3 = monome 1. 0 ++ monome 2. 1 ++ monome (-1.) 2 ++ 
	 monome 5. 2 ++ monome 2. 2
let p4 = monome 2. 0 ++ monome (-3.) 1 ++ monome 2. 2
let p5 = monome 2. 0

let _ =
  print_newline();
  print_string " exemples de polynomes definis sur le corps des rels ";
  print_newline();
  print_string "les polynmes"; print_newline();
  print_string "p1: ";
  print p1;
  print_newline();
  print_string "p2: ";
  print p2;
  print_newline();
  print_newline();
  flush(stdout);

  print_string "degre de p1 : ";
  print_int (degree p1);
  print_newline();
  print_newline();

  print_string"addition"; print_newline();
  print ( p1 ++ p2 );
  print_newline(); print_newline();
  
  print_string"soustraction";   print_newline();
  print ( p1 -- p2 );
  print_newline(); print_newline();
  
  print_string"multiplication"; print_newline();  
  print ( p1 ** p2 );
  print_newline(); print_newline();
  
  print_string"multiplication par un scalaire (ex: -5.5*p1)";
  print_newline();  
  print ( (-5.5) @ p1  );
  print_newline(); print_newline();

  print_string"division euclidienne de";
  print_newline();
  print p3;
  print_string "     par     ";
  print p4;   print_string " = ";
  print_newline();
  print (p3 // p4);
  print_string "  reste = ";
  print (p3 mod p4);
  print_newline();
  print_string"div*quotient+reste = ";
  print_newline();
  print ((p3 mod p4) ++ (p4 ** (p3 // p4)));
  print_newline(); print_newline();
 
  
  print_string "drivation de :  ";
  print p4;
  print_newline();  
  print ( derive p4 );
  print_newline(); print_newline();

  print_string "intgration du rsultat prcdant avec c=0";
  print_newline();  
  print (int  (derive p4) ); 
  print_newline(); 
  print_newline();
  print_string " operation avec le polynme nul ";
  print_newline();
  print_string " p1 + zero = "; 
  print ( p1 ++ zero );
  print_newline();
  print_string "p1 * zero = "; 
  print (p1 ** zero );
  print_newline();
  print_newline();
