open Format
open Algebra
open Utils


open E

let rec fexp = {name = "exp"; calcul = exp; deriv = Tra(fexp, (var "x"));name_var = "x"}
let rec flog = {name = "log"; calcul = log; deriv = inv(var "x");name_var = "x"}
let rec fsin = {name = "sin"; calcul = sin; deriv = Tra(fcos, (var "x"));name_var = "x"}
    and fcos = {name = "cos"; calcul = cos; deriv = Mul(cst (-1.0), Tra(fsin, (var "x")));name_var = "x"}

let x= var "x"
let y = var "y"
let z = var "z"

let f = Pow(x,2) ++ Pow(y,2) -- Pow(z,2) 
let g = Pow(x,3) ++ Pow(y,3) ++ Pow(z,3) 
let h = x ** y ++ x ** z ++ y ** z 

let _ = 
  E.print f;
  print_newline ();
  VF.print (grad f);
  print_newline ();
  MF.print (hess f);
  print_newline ();
  E.print (curv f);
  print_newline ();
  E.print g;
  print_newline ();
  VF.print (grad g);
  print_newline ();
  MF.print (hess g);
  print_newline ();
  E.print (curv g);
  print_newline ();
  E.print h;
  print_newline ();
  VF.print (grad h);
  print_newline ();
  MF.print (hess h);
  print_newline ();
  E.print (curv h);
  print_newline ()

